## ngspice 45.2+ds

=== src/include/cppduals/CMakeLists.txt ===
#
# CMake for cppduals
#
cmake_minimum_required (VERSION 3.14)
project (cppduals
  VERSION 0.6.2
  LANGUAGES C CXX
  )
include (GNUInstallDirs)

if (NOT CMAKE_CXX_STANDARD)
  set (CMAKE_CXX_STANDARD 17 CACHE STRING "Which C++ standard to test against.")
endif()
message (STATUS "CXX_STANDARD: ${CMAKE_CXX_STANDARD}")
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    message (STATUS "Configuring cppduals for standalone build")
    set (CPPDUALS_STANDALONE TRUE)
elseif ()
    message (STATUS "Configuring cppduals for subproject build")
    set (CPPDUALS_STANDALONE FALSE)
endif ()
if (CPPDUALS_STANDALONE AND
    NOT CMAKE_CONFIGURATION_TYPES AND
    NOT CMAKE_NO_BUILD_TYPE AND
    NOT CMAKE_BUILD_TYPE
    )
  message (STATUS "Setting build type to 'RelWithDebInfo' since none specified")
  set_property (CACHE CMAKE_BUILD_TYPE PROPERTY VALUE RelWithDebInfo)
  set_property (CACHE CMAKE_BUILD_TYPE PROPERTY
    STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo"
    )
endif ()
if (CPPDUALS_STANDALONE AND
    CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set (CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install"
       CACHE PATH "cppduals installation directory"
       FORCE
       )
  message (STATUS "No install prefix specified; using '${CMAKE_INSTALL_PREFIX}'")
endif ()

#set_property (CACHE CMAKE_CXX_STANDARD PROPERTY STRINGS 11 14 17 20)
set_property (CACHE CMAKE_CXX_STANDARD PROPERTY STRINGS 20)

option (CPPDUALS_TESTING "Enable testing" OFF)
option (CPPDUALS_BENCHMARK "Enable benchmarking" OFF)
option (CPPDUALS_USE_LIBCXX "When testing use flags for libc++" OFF)
set (EIGEN3_INCLUDE_DIRS "" CACHE PATH "Path to Eigen includes" )

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
    "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wpedantic")
endif ()

if (CPPDUALS_BENCHMARK)
  set (CPPDUALS_TESTING ON)
endif (CPPDUALS_BENCHMARK)

if (CPPDUALS_USE_LIBCXX)
  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    add_compile_options ("-stdlib=libc++")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++ ") # -lc++abi
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
      "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    # this is unfinished...
    set (CPPDUALS_CXX_FLAGS "${CMAKE_CXX_FLAGS} -nostdinc++")
    message (WARNING "libc++ header path must be manually specified using CMAKE_CXX_FLAGS")
    list (APPEND CPPDUALS_CXX_LINKER_FLAGS -nodefaultlibs)
    list (APPEND CPPDUALS_CXX_LIBRARIES c++)
  else ()
    message(FATAL_ERROR "-DCPPDUALS_USE_LIBCXX:BOOL=ON is not supported for this compiler")
  endif ()
endif (CPPDUALS_USE_LIBCXX)

#
# Primary Library Target
#
add_library (cppduals_duals INTERFACE)
target_include_directories (cppduals_duals
  INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    )
set_target_properties (cppduals_duals
  PROPERTIES
    EXPORT_NAME duals
    )
add_library (cppduals::duals ALIAS cppduals_duals)

#
# Build external dependencies for testing & benchmarking
#
if (CPPDUALS_TESTING)

  cmake_minimum_required (VERSION 3.14) # need gtest_discover_tests
  file (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/thirdparty")

  # generator name
  if (NOT "${CMAKE_EXTRA_GENERATOR}" STREQUAL "")
    set (GENERATOR_STRING "${CMAKE_EXTRA_GENERATOR} - ${CMAKE_GENERATOR}")
  else ()
    set (GENERATOR_STRING "${CMAKE_GENERATOR}")
  endif ()

  # configure the thirdparty build dir
  execute_process (
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/thirdparty"
    COMMAND ${CMAKE_COMMAND} "-G${GENERATOR_STRING}"
                             "-DCMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}"
                             "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
                             "-DCMAKE_MAKE_PROGRAM=${CMAKE_MAKE_PROGRAM}"
                             "-DCPPDUALS_BENCHMARK=${CPPDUALS_BENCHMARK}"
                             "-DCPPDUALS_USE_LIBCXX=${CPPDUALS_USE_LIBCXX}"
                             "${PROJECT_SOURCE_DIR}/thirdparty"
    RESULT_VARIABLE DEPS_CONFIG_RESULT
    )
  if (DEPS_CONFIG_RESULT)
    message (FATAL_ERROR "Configuring dependencies failed: ${DEPS_CONFIG_RESULT}")
  endif ()

  # build the thirdparty
  message ("***************************************************************")
  message ("** Building '${PROJECT_BINARY_DIR}/thirdparty'...")
  message ("***************************************************************")
  execute_process (
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/thirdparty"
    COMMAND "${CMAKE_COMMAND}" --build .
    RESULT_VARIABLE DEPS_BUILD_RESULT
    )
  message ("***************************************************************")
  message ("*** Building thirdparty/ done.")
  message ("***************************************************************")
  if (DEPS_BUILD_RESULT)
    message ("***************************************************************")
    message (FATAL_ERROR "Building dependencies failed: ${DEPS_BUILD_RESULT}")
    message ("***************************************************************")
  endif ()

  add_subdirectory (thirdparty)

endif ()

#
# Code Coverage Configuration
#
add_library (cppduals_coverage_config INTERFACE)
option (CPPDUALS_CODE_COVERAGE "Enable coverage reporting" OFF)
if (CPPDUALS_CODE_COVERAGE AND NOT CPPDUALS_TESTING)
  message(FATAL_ERROR "CPPDUALS_CODE_COVERAGE requires CPPDUALS_TESTING to be enabled")
endif()
if (CPPDUALS_CODE_COVERAGE)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    message(STATUS "Enabling coverage reporting")
    # Add required flags (GCC & LLVM/Clang)
    target_compile_options (cppduals_coverage_config INTERFACE
      -O0        # no optimization
      -g         # generate debug info
      --coverage # sets all required flags
      -fprofile-arcs 
      -ftest-coverage
    )
    target_link_options (cppduals_coverage_config INTERFACE 
      --coverage
    )
  else()
    # error out if coverage is enabled but compiler is not supported
    message(FATAL_ERROR "Coverage reporting is disabled for unknown compilers.")
  endif ()
endif ()

#
# Testing
#
if (CPPDUALS_TESTING)
  enable_testing ()
  include (CTest)
  add_subdirectory (tests)
endif (CPPDUALS_TESTING)

#
# Documentation
#
find_program (DOXYGEN doxygen)
if (DOXYGEN)
  configure_file (${PROJECT_SOURCE_DIR}/doc/Doxyfile.in       ${PROJECT_BINARY_DIR}/doc/Doxyfile)
  configure_file (${PROJECT_SOURCE_DIR}/doc/DoxygenLayout.xml ${PROJECT_BINARY_DIR}/doc/DoxygenLayout.xml COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/header.html       ${PROJECT_BINARY_DIR}/doc/header.html COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/footer.html       ${PROJECT_BINARY_DIR}/doc/footer.html COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/favicon.ico       ${PROJECT_BINARY_DIR}/doc/favicon.ico COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/customdoxygen.css ${PROJECT_BINARY_DIR}/doc/customdoxygen.css)
  add_custom_target (cppduals_docs
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/doc
    COMMAND cmake -E remove_directory ${PROJECT_BINARY_DIR}/docs
    COMMAND ${DOXYGEN} Doxyfile
    )
else ()
  add_custom_target (cppduals_docs
    COMMAND echo "Please install doxygen and reconfigure to build the docs"
    )
endif ()

#
# Installation
#
install (TARGETS cppduals_duals EXPORT cppduals_export)
install (EXPORT cppduals_export
  FILE cppduals-config.cmake
  NAMESPACE cppduals::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/cppduals
  )
install (
  DIRECTORY ${PROJECT_SOURCE_DIR}/duals
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PATTERN "*~" EXCLUDE
  )
install (
  DIRECTORY ${PROJECT_BINARY_DIR}/docs/   # Trailing slash triggers rename
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/doc/cppduals
  OPTIONAL
  )

#
# etags
#
find_program (ETAGS etags)
if (ETAGS)
  add_custom_target (cppduals_etags
    COMMAND ${ETAGS} --language=c++ ${PROJECT_SOURCE_DIR}/duals/*
    COMMAND ${ETAGS} --language=c++ --append ${PROJECT_SOURCE_DIR}/duals/arch/*/*
    COMMAND ${ETAGS} --language=c++ --append `find ${PROJECT_BINARY_DIR}/thirdparty/eigenX/src/eigenX -type f`
    )
endif (ETAGS)

#
# Packaging
#
include (CPack)

=== src/include/cppduals/tests/CMakeLists.txt ===
#
# Part of the cppduals Project
#
# (c)2019 Michael Tesch. tesch1@gmail.com
#
# See https://gitlab.com/tesch1/cppduals/blob/master/LICENSE.txt for
# license information.
#
# This Source Code Form is subject to the terms of the Mozilla
# Public License v. 2.0. If a copy of the MPL was not distributed
# with this file, You can obtain one at http://mozilla.org/MPL/2.0/.

cmake_minimum_required (VERSION 3.14)

if (WIN32)
  add_definitions (-D_USE_MATH_DEFINES)
endif ()
include_directories ("${CMAKE_SOURCE_DIR}")
include_directories ("${DEPS_ROOT}/include")
#include_directories ("${MPFR_INCLUDES}")

#
# Correctness & Coverage
#
message ("OSX_ARCHITECTURES: ${CMAKE_SYSTEM_PROCESSOR}")
set (OSX_ARCHITECTURES "arm64;x86_64")
if (CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
  set (X86 TRUE)
else ()
  set (X86 FALSE)
endif ()

# Set optimization flags only if coverage is not enabled
if (NOT CPPDUALS_CODE_COVERAGE)
  if (X86)
    if (NOT MSVC)
      set (OPT_FLAGS "-O3;-march=native")
    else ()
      set (OPT_FLAGS "/arch:AVX2")
    endif ()
  else ()
    set (OPT_FLAGS "-O3")
  endif ()
else()
  if (X86)
    if (NOT MSVC)
      set (OPT_FLAGS "-mavx2")
    else ()
      set (OPT_FLAGS "/arch:AVX2")
    endif ()
  else ()
    set (OPT_FLAGS "")
  endif ()
endif ()

set (OPT_FLAGS "${OPT_FLAGS};-DCPPDUALS_VECTORIZE_CDUAL")

set (ALL_TESTS
  test_dual test_cdual test_funcs test_eigen test_packets
  test_vectorize test_solve test_expm test_1 test_fmt
  example
  )
set (ALL_TEST_BINS )
foreach (TEST_ ${ALL_TESTS})
  foreach (PHASE 1 2 3 4 5)
    # check if file has phase defined
    file (READ ${TEST_}.cpp TMPTXT)
    string (FIND "${TMPTXT}" "PHASE_${PHASE}" hasphase)
    if ((${hasphase} EQUAL -1) AND NOT (${PHASE} EQUAL 1))
      continue ()
    endif ()

    set (TEST ${TEST_}_${PHASE})
    message ("Adding test ${TEST}")
    set (ALL_TEST_BINS ${ALL_TEST_BINS} ${TEST})

    add_executable (${TEST} ${TEST_}.cpp)
    set (PHASE_FLAGS ${OPT_FLAGS} -DPHASE_${PHASE})
    string (REPLACE ";" ", " L2 "${OPT_FLAGS};${CMAKE_CXX_FLAGS}")
    target_compile_options (${TEST} PUBLIC ${PHASE_FLAGS})
    target_compile_definitions (${TEST} PRIVATE "OPT_FLAGS=${L2}")
    
    # Link with coverage config first to ensure flags are used
    target_link_libraries (${TEST} 
      cppduals_coverage_config  # Link coverage first
      gtest_main 
      eigen 
      expokit
    )
    
    gtest_discover_tests (${TEST} TEST_LIST ${TEST}_targets)
    set_tests_properties (${${TEST}_targets} PROPERTIES TIMEOUT 10)
  endforeach (PHASE)
endforeach (TEST_)

# special for fmt
target_link_libraries (test_fmt_1 fmt::fmt)

if (CPPDUALS_BENCHMARK)
  #
  # Benchmarks
  #
  if (Boost_FOUND AND NO)
    add_definitions (-DHAVE_BOOST=1)
    include_directories ("${Boost_INCLUDE_DIRS}")
    include_directories ("${PIRANHA_INCLUDE_DIR}")
    include_directories ("${AUDI_INCLUDE_DIR}")
  endif (Boost_FOUND AND NO)

  if (NOT APPLE AND NOT BLA_VENDOR)
    if (NOT BLA_STATIC)
      # default to static
      set (BLA_STATIC OFF)
    endif (NOT BLA_STATIC)
    set (BLA_VENDOR OpenBLAS)
  endif ()
  find_package (BLAS REQUIRED)
  #find_package (LAPACK REQUIRED)
  add_definitions (-DHAVE_BLAS)
  #add_definitions (-DEIGEN_USE_BLAS)
  if (APPLE)
    add_definitions (-DACCELERATE_NEW_LAPACK -DACCELERATE_LAPACK_ILP64)
  endif ()

  # find lapacke.h cblas.h
  set (CBLAS_HINTS ${BLAS_DIR} ${LAPACK_DIR} /usr /usr/local /opt /opt/local)
  set (CBLAS_PATHS
    /usr
    /usr/local
    /opt
    /opt/local
    /usr/local/opt
    /System/Library/Frameworks
    ${BLAS_LIBRARIES}
    )

  # Finds the include directories for lapacke.h
  find_path (LAPACKE_INCLUDE_DIRS
    REQUIRED
    NAMES lapacke.h clapack.h
    HINTS ${CBLAS_HINTS}
    PATH_SUFFIXES
    include inc include/x86_64 include/x64
    openblas/include openblas
    Frameworks/vecLib.framework/Headers
    PATHS ${CBLAS_PATHS}
    DOC "LAPACK(E) include header lapacke.h/clapack.h")
  mark_as_advanced (LAPACKE_INCLUDE_DIRS)
  if (LAPACKE_INCLUDE_DIRS)
    include_directories (${LAPACKE_INCLUDE_DIRS})
  else ()
    add_definitions (-DEIGEN_LAPACKE)
  endif (LAPACKE_INCLUDE_DIRS)

  # Finds the include directories for cblas*.h
  find_path (CBLAS_INCLUDE_DIRS
    REQUIRED
    NAMES cblas.h cblas_openblas.h cblas-openblas.h
    HINTS ${CBLAS_HINTS}
    PATH_SUFFIXES
    include inc include/x86_64 include/x64
    openblas/include openblas
    Frameworks/vecLib.framework/Headers
    PATHS ${CBLAS_PATHS}
    DOC "BLAS include header cblas.h")
  mark_as_advanced (CBLAS_INCLUDE_DIRS)
  include_directories (${CBLAS_INCLUDE_DIRS})
  foreach (cblas in cblas.h cblas_openblas.h cblas-openblas.h)
    if (EXISTS "${CBLAS_INCLUDE_DIRS}/${cblas}")
      add_definitions (-DCBLAS_HEADER="${cblas}")
      break()
    endif (EXISTS "${CBLAS_INCLUDE_DIRS}/${cblas}")
  endforeach (cblas)
  message ("Found BLAS    : ${BLAS_LIBRARIES}")
  message ("Found cBLAS   : ${CBLAS_INCLUDE_DIRS}")
  message ("Found lapacke : ${LAPACKE_INCLUDE_DIRS}")

  set (BMK_FLAGS "")
  if (NOT MSVC)
    #set (BMK_FLAGS "-O3;-mavx")
    #set (BMK_FLAGS "-O3;-march=native;-fopenmp")
    if (X86)
      set (BMK_FLAGS "-msse3;-fopenmp")
      set (BMK_FLAGS "-msse3")
      set (BMK_FLAGS "-march=native;-funroll-loops")
      set (BMK_FLAGS "-msse3;-mavx2;-mfma")
    else ()
      set (BMK_FLAGS "-march=native")
    endif ()
    #set (BMK_FLAGS "-O3;${BMK_FLAGS}")
    #set (BMK_FLAGS "${BMK_FLAGS};-save-temps;-fverbose-asm")
  else ()
    set (BMK_FLAGS "/arch:IA32")
    set (BMK_FLAGS "/arch:SSE")
    set (BMK_FLAGS "/arch:SSE2")
    set (BMK_FLAGS "/arch:AVX2")
  endif ()

  #set (BMK_FLAGS "${BMK_FLAGS};-DEIGEN_DONT_VECTORIZE")
  #set (BMK_FLAGS "${BMK_FLAGS};-DCPPDUALS_DONT_VECTORIZE")
  #set (BMK_FLAGS "${BMK_FLAGS};-DCPPDUALS_DONT_VECTORIZE_CDUAL")

  foreach (VECTORIZE YES NO)
    foreach (BENCH  bench_dual bench_eigen bench_exp bench_gemm bench_example bench_fmt)
      if (NOT VECTORIZE)
        set (BENCHE ${BENCH})
      else ()
        set (BENCHE ${BENCH}_novec)
      endif ()
      add_executable (${BENCHE} ${BENCH}.cpp)
      target_compile_options (${BENCHE} PUBLIC ${BMK_FLAGS})
      if (NOT VECTORIZE)
        target_compile_options (${BENCHE} PUBLIC "-DEIGEN_DONT_VECTORIZE")
      endif()
      #set_target_properties (${BENCH} PROPERTIES LINK_FLAGS -fopenmp)
      #target_link_options (${BENCH} PUBLIC ${BMK_FLAGS})
      string (REPLACE ";" ", " L2 "${BMK_FLAGS} ${CMAKE_CXX_FLAGS}")
      target_compile_definitions (${BENCHE} PRIVATE "BMK_FLAGS=${L2}")
      target_link_libraries (${BENCHE} benchmark::benchmark ${BLAS_LIBRARIES} eigen expokit)
    endforeach ()
  endforeach ()

  target_link_libraries (bench_fmt fmt::fmt)
  target_link_libraries (bench_fmt_novec fmt::fmt)

endif (CPPDUALS_BENCHMARK)

add_executable (sandbox sandbox.cpp)
#target_compile_options (sandbox PUBLIC ${BMK_FLAGS})
target_compile_options (sandbox PUBLIC -DCPPDUALS_VECTORIZE_CDUAL)
if (MSVC)
  if (X86)
    target_compile_options (sandbox PUBLIC /arch:AVX2)
  endif ()
else ()
  if (X86)
    target_compile_options (sandbox PUBLIC -O1 -msse3 -mavx2 -mfma)
  else ()
    target_compile_options (sandbox PUBLIC -O1 )  # -mfpu=neon
  endif ()
endif ()

set_target_properties (sandbox PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
target_link_libraries (sandbox PUBLIC cppduals_coverage_config eigen expokit)

#
# Generate coverage reports
#
if (CPPDUALS_CODE_COVERAGE)
  # Find required tools
  get_filename_component(CMAKE_CXX_COMPILER_DIR "${CMAKE_CXX_COMPILER}" DIRECTORY)
  set(GENHTML_PATH ${CMAKE_CXX_COMPILER_DIR}/genhtml)
  if(NOT EXISTS ${GENHTML_PATH})
    find_program(GENHTML_PATH genhtml REQUIRED)
  endif()

  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # Clang
    # often in the same directory as clang - search there too
    get_filename_component(CMAKE_CXX_COMPILER_DIR "${CMAKE_CXX_COMPILER}" DIRECTORY)
    set(LLVM_COV_PATH ${CMAKE_CXX_COMPILER_DIR}/llvm-cov)
    set(LLVM_PROFDATA_PATH ${CMAKE_CXX_COMPILER_DIR}/llvm-profdata)
    if(NOT EXISTS ${LLVM_COV_PATH})
      find_program(LLVM_COV_PATH llvm-cov REQUIRED)
    endif()
    if(NOT EXISTS ${LLVM_PROFDATA_PATH})
      find_program(LLVM_PROFDATA_PATH llvm-profdata REQUIRED)
    endif()
    
    add_custom_target(cov
      DEPENDS ${ALL_TEST_BINS}
      COMMAND ${CMAKE_COMMAND} -E remove_directory coverage/profraw
      COMMAND ${CMAKE_COMMAND} -E make_directory coverage/profraw
      COMMAND ${CMAKE_COMMAND} --build . --target test "LLVM_PROFILE_FILE=coverage/profraw/%p.profraw"
      COMMAND ${LLVM_PROFDATA_PATH} merge -sparse coverage/profraw/*.profraw -o coverage/coverage.profdata
      COMMAND ${LLVM_COV_PATH} show
        -instr-profile=coverage/coverage.profdata
        -format=html -output-dir=coverage/html
        -show-line-counts-or-regions
        -show-instantiation-summary
        ${ALL_TEST_BINS}
      COMMAND ${LLVM_COV_PATH} report
        -instr-profile=coverage/coverage.profdata
        ${ALL_TEST_BINS}
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
  elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    # GCC
    set(LCOV_PATH ${CMAKE_CXX_COMPILER_DIR}/lcov)
    if(NOT EXISTS ${LCOV_PATH})
      find_program(LCOV_PATH lcov REQUIRED)
    endif()
    # Extract GCC version number and use matching gcov version
    execute_process(
      COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
      OUTPUT_VARIABLE GCC_VERSION
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(GCOV_PATH ${CMAKE_CXX_COMPILER_DIR}/gcov-${GCC_VERSION})
    if(NOT EXISTS ${GCOV_PATH})
      find_program(GCOV_PATH gcov-${GCC_VERSION} REQUIRED)
    endif()
  
    add_custom_target(cov
      DEPENDS ${ALL_TEST_BINS}
      COMMAND ${CMAKE_COMMAND} -E make_directory coverage
      COMMAND ${LCOV_PATH} --directory . --zerocounters
      # Add initial capture before running tests
      COMMAND ${LCOV_PATH} --directory . --capture --initial --gcov-tool ${GCOV_PATH} --output-file coverage/coverage.base --ignore-errors inconsistent
      # Run tests and capture coverage data
      COMMAND ctest --output-on-failure
      COMMAND ${LCOV_PATH} --directory . --capture --gcov-tool ${GCOV_PATH} --output-file coverage/coverage.info --ignore-errors inconsistent
      # Combine baseline and test coverage data
      COMMAND ${LCOV_PATH} --add-tracefile coverage/coverage.base --add-tracefile coverage/coverage.info --gcov-tool ${GCOV_PATH} --output-file coverage/coverage.total
      # Only look at the coverage of the tests and duals library
      COMMAND ${LCOV_PATH} --extract coverage/coverage.total '*/tests/*' '*/duals/*' --gcov-tool ${GCOV_PATH} --output-file coverage/coverage.info
      # Remove unwanted paths
      #COMMAND ${LCOV_PATH} --remove coverage/coverage.total '/usr/*' --gcov-tool ${GCOV_PATH} --output-file coverage/coverage.info
      #COMMAND ${LCOV_PATH} --remove coverage/coverage.info '*/thirdparty/*' --gcov-tool ${GCOV_PATH} --output-file coverage/coverage.info
      #COMMAND ${LCOV_PATH} --remove coverage/coverage.info '*/googletest/*' --gcov-tool ${GCOV_PATH} --output-file coverage/coverage.info
      # Add --ignore-errors empty to prevent failure on empty coverage data
      COMMAND ${LCOV_PATH} --list coverage/coverage.info --ignore-errors empty --gcov-tool ${GCOV_PATH}
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
  else()
    message(FATAL_ERROR "No coverage tool found for ${CMAKE_CXX_COMPILER_ID}")
  endif()

  add_custom_target(cov-html
    DEPENDS cov
    COMMAND ${CMAKE_COMMAND} -E remove_directory coverage/html
    COMMAND ${GENHTML_PATH} --ignore-errors source coverage/coverage.info --legend --title "cppduals coverage"
      --output-directory=coverage/html
    COMMAND ${CMAKE_COMMAND} -E echo "Coverage report generated at coverage/html/index.html"
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )

endif ()

=== src/include/cppduals/thirdparty/CMakeLists.txt ===

# https://gist.github.com/johnb003/65982fdc7a1274fdb023b0c68664ebe4

# 3.10 adds support for "gtest_discover_tests" which enumerates the tests inside
# of the code and adds them to ctest.
#
cmake_minimum_required (VERSION 3.14)
project (cppduals_thirdparty)
include (ExternalProject)

get_directory_property (hasParent PARENT_DIRECTORY)

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.23)
  cmake_policy (SET CMP0135 NEW)
endif ()
if (CMAKE_XCODE_BUILD_SYSTEM VERSION_GREATER_EQUAL 12)
  cmake_policy (SET CMP0114 NEW)
endif ()

set (DEPS_ROOT "${CMAKE_BINARY_DIR}/root")
if (hasParent)
  set (DEPS_ROOT "${CMAKE_BINARY_DIR}/thirdparty/root" PARENT_SCOPE)
endif (hasParent)

if (NOT WIN32)
  set (DOWNLOAD_DIR "$ENV{HOME}/Downloads")
else (NOT WIN32)
  set (DOWNLOAD_DIR "C:/Downloads")
endif (NOT WIN32)

include(FetchContent)

#
# Google test
# https://google.github.io/googletest/quickstart-cmake.html

# 
# Configure google-test
FetchContent_Declare(
  googletest
  URL https://github.com/google/googletest/archive/refs/tags/v1.15.2.zip
  URL_HASH MD5=eb1c5c237d13ed12bf492d3997ca6b0d
  DOWNLOAD_NAME googletest-v1.15.2.zip
  DOWNLOAD_DIR "$ENV{HOME}/Downloads"
)

# For Windows: Prevent overriding the parent project's compiler/linker settings
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(googletest)

# Enable testing
include(GoogleTest)

#
# Eigen
#
if (TRUE)
  set (EIGEN_URL https://gitlab.com/libeigen/eigen/-/archive/3.3.8/eigen-3.3.8.tar.bz2)
  set (EIGEN_MD5 432ef01499d514f4606343276afa0ec3)
  set (EIGEN_MAX_CXX 17)
else ()
  set (EIGEN_URL https://gitlab.com/libeigen/eigen/-/archive/3.3.7/eigen-3.3.7.tar.bz2)
  set (EIGEN_MD5 b9e98a200d2455f06db9c661c5610496)
  set (EIGEN_MAX_CXX 17)
endif ()
#
# Eigen
#
ExternalProject_Add (eigenX
  PREFIX eigenX
  URL ${EIGEN_URL}
  URL_HASH MD5=${EIGEN_MD5}
  DOWNLOAD_DIR "$ENV{HOME}/Downloads"
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  LOG_DOWNLOAD ON
  )
ExternalProject_Get_Property (eigenX source_dir)
if (true) # || hasParent
  add_library (eigen INTERFACE IMPORTED GLOBAL)
  add_dependencies (eigen eigenX)
  set_property (TARGET eigen APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${source_dir}")
  if (XCODE)
    set (IOFORMAT "IOFormat\(FullPrecision, DontAlignCols, \", \", \"\\$<SEMICOLON>\\\\n\", \"\", \"\", \"[\", \"]\"\)")
  else ()
    set (IOFORMAT "IOFormat\(FullPrecision, DontAlignCols, \", \", \"\\$<SEMICOLON>\\n\", \"\", \"\", \"[\", \"]\"\)")
  endif ()
  #target_compile_definitions (eigen INTERFACE EIGEN_DEFAULT_IO_FORMAT=${IOFORMAT})
  #target_compile_definitions (eigen INTERFACE EIGEN_DEFAULT_IO_FORMAT=EIGEN_IO_FORMAT_OCTAVE)
  set_property (TARGET eigen APPEND PROPERTY
    INTERFACE_COMPILE_DEFINITIONS EIGEN_DEFAULT_IO_FORMAT=${IOFORMAT})
endif ()

# if c++20, disable warning -Wdeprecated-enum-enum-conversion to eigen
if (CMAKE_CXX_STANDARD GREATER_EQUAL 20)
  target_compile_options (eigen INTERFACE -Wno-deprecated-enum-enum-conversion)
endif ()

#
# expokit
#
#set (EEX_SHA  ee28baa3bf29561501e17e5c68c2e54c85daae19  ) newer? used by spindropsSDL. md5=cebd15f9b5068c0e327753244ff6d394
set (EEX_SHA c157dec0057be6e183a1ea2a5de353fac7e5e3a7 )
set (EEX_MD5 89484e51f706398284235b96bc805515 )
ExternalProject_Add (expokitX
  PREFIX expokitX
  URL https://gitlab.com/tesch1/eigen-expokit/-/archive/${EEX_SHA}/eigen-expokit.tar.bz2
  URL_HASH MD5=${EEX_MD5}
  DOWNLOAD_NAME eigen-expokit-${EEX_SHA}.tar.bz2
  DOWNLOAD_DIR "$ENV{HOME}/Downloads"
  UPDATE_COMMAND ""
  PATCH_COMMAND ""
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  LOG_DOWNLOAD ON
  )
ExternalProject_Get_Property (expokitX source_dir)
if (hasParent)
  add_library (expokit INTERFACE IMPORTED GLOBAL)
  add_dependencies (expokit expokitX)
  set_property (TARGET expokit APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${source_dir}")
endif (hasParent)


#
# fmt
#
ExternalProject_Add (fmtX
  PREFIX fmtX
  URL https://github.com/fmtlib/fmt/archive/11.1.4.tar.gz
  URL_HASH MD5=10c2ae163accd3b82e6b8b4dff877645
  DOWNLOAD_DIR ${DOWNLOAD_DIR}
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  )
ExternalProject_Get_Property (fmtX source_dir)
ExternalProject_Get_Property (fmtX binary_dir)
if (hasParent)
  add_subdirectory (${source_dir} ${binary_dir} EXCLUDE_FROM_ALL)
endif ()

if (CPPDUALS_BENCHMARK)
  #
  # google benchmark
  #
  ExternalProject_Add (benchmarkX
    PREFIX benchmarkX
    URL "http://github.com/google/benchmark/archive/v1.9.1.tar.gz"
    URL_HASH MD5=92000ef8b4a7b1e9229972f8943070a7
    DOWNLOAD_DIR ${DOWNLOAD_DIR}
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
    )
  ExternalProject_Get_Property (benchmarkX source_dir)
  ExternalProject_Get_Property (benchmarkX binary_dir)
  if (hasParent)
    # https://github.com/google/benchmark#requirements
    set (BENCHMARK_ENABLE_GTEST_TESTS OFF)
    set (BENCHMARK_USE_LIBCXX ${CPPDUALS_USE_LIBCXX})
    add_subdirectory (${source_dir} ${binary_dir} EXCLUDE_FROM_ALL)
  endif()

  if (Boost_FOUND AND NO)

    #
    # Audi + Piranha - needs boost
    #
    #boost 1.70
    find_package (Boost 1.69)
    if (hasParent)
      set (Boost_FOUND ${Boost_FOUND} PARENT_SCOPE)
      set (Boost_INCLUDE_DIRS ${Boost_INCLUDE_DIRS} PARENT_SCOPE)
    endif ()

    # AuDi
    ExternalProject_Add (audiX PREFIX audiX
      URL https://github.com/darioizzo/audi/archive/v1.6.5.tar.gz
      URL_HASH MD5=a51897469dfce4ceaa25e65519a346b9
      DOWNLOAD_DIR "$ENV{HOME}/Downloads"
      #CONFIGURE_COMMAND ""
      CMAKE_ARGS -DAUDI_BUILD_TESTS=OFF
      BUILD_COMMAND "" INSTALL_COMMAND ""
      )
    ExternalProject_Get_Property (audiX source_dir)
    if (hasParent)
      set (AUDI_INCLUDE_DIR "${source_dir}/include" PARENT_SCOPE)
    endif ()
  endif (Boost_FOUND AND NO)
endif (CPPDUALS_BENCHMARK)

#
# multi-precision math
#
if (0)
ExternalProject_Add (mpfrX
  PREFIX mpfrX
  URL https://www.mpfr.org/mpfr-current/mpfr-4.0.2.tar.bz2
  URL_HASH MD5=6d8a8bb46fe09ff44e21cdbf84f5cdac
  DOWNLOAD_DIR ${DOWNLOAD_DIR}
  CONFIGURE_COMMAND "../mpfrX/configure" --prefix=<INSTALL_DIR>
  #BUILD_COMMAND "make install"
  #INSTALL_COMMAND "make install"
  )
# clumsy download link - retrieves "archive.tar"
ExternalProject_Add (mprealX
  PREFIX mprealX
  URL "http://www.holoborodko.com/pavel/wp-content/plugins/download-monitor/download.php?id=4"
  URL_HASH MD5=68ad2258eb4a1c699c407f0e7bee5125
  DOWNLOAD_DIR ${DOWNLOAD_DIR}
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  )
ExternalProject_Get_Property (mprealX source_dir)
ExternalProject_Get_Property (mpfrX INSTALL_DIR)
if (hasParent)
  set (MPFR_INCLUDES "${INSTALL_DIR}/include" "${source_dir}" PARENT_SCOPE)
  set (MPFR_LIBRARIES "${INSTALL_DIR}/lib/libmpfr.a" -lgmp PARENT_SCOPE)
  message (" MPFR_INCLUDES: ${MPFR_INCLUDES}")
  add_definitions (-DHAVE_MPFR)
endif (hasParent)
endif (0)

=== debian/control ===
Source: ngspice
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders:
 Gudjon I. Gudjonsson <gudjon@gudjon.org>,
 Andreas Tille <tille@debian.org>,
 Carsten Schoenert <c.schoenert@t-online.de>,
Build-Depends:
 automake,
 bison,
 blt-dev,
 debhelper-compat (= 13),
 flex,
 gfortran,
 libedit-dev,
 libncurses-dev,
 libreadline-dev,
 libtool,
 libxaw7-dev,
 tcl8.6,
 tcl8.6-dev,
 texinfo,
 tk8.6,
 tk8.6-dev,
Build-Depends-Indep:
 imagemagick,
 lyx (>= 2.2),
 texlive,
 texlive-lang-greek,
 texlive-latex-extra,
 texlive-plain-generic,
 texlive-science,
Rules-Requires-Root: binary-targets
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/electronics-team/ngspice
Vcs-Git: https://salsa.debian.org/electronics-team/ngspice.git
Homepage: https://ngspice.sourceforge.io

Package: ngspice
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ngspice-doc (>= ${source:Version}),
Description: Spice circuit simulator
 NGSpice is a mixed-level/mixed-signal circuit simulator.  Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
 the built-in OSDI interface.
 .
 NGSpice is part of gEDA project, a full GPL'd suite of Electronic Design
 Automation tools.

Package: ngspice-dev
Section: libdevel
Architecture: any
Depends:
 blt-dev,
 tclspice (= ${binary:Version}),
 ${misc:Depends},
Description: Spice circuit simulator - development files for ngspice and tclspice
 NGSpice is a mixed-level/mixed-signal circuit simulator. Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
 the built-in OSDI interface.
 .
 Use this package in case you need to compile own Xspice models as a dynamic
 library with a file extension *.cm. Those files need to be placed into
 /usr/lib/$(multiarch)/ngspice and will be loaded by the ngspice executable.
 .
 This package contains the development header files for libspice and own
 ngspice dynamic library models.

Package: tclspice
Section: libs
Architecture: any
Depends:
 blt,
 ngspice (= ${binary:Version}),
 tcl8.6,
 tk8.6,
 ${misc:Depends},
 ${shlibs:Depends},
Description: NGSpice library for Tcl
 This package provides the NGSpice simulation engine for your Tcl-scripts by the
 library libspice.
 All spice directives are available as Tcl functions and it features some new
 commands that are useful for the integration into the Tcl environment. It
 includes Xspice. It supports also compiled Verilog-A models through the
 built-in OSDI interface.
 GUI is handled by Tk using BLT vectors.

Package: ngspice-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Documentation for the NGspice circuit simulator
 NGspice is a mixed-level/mixed-signal circuit simulator.
 Its code is based on three open source software packages:
 Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
 the built-in OSDI interface.
 .
 NGSpice is part of gEDA project, a full GPL'd suite of Electronic Design
 Automation tools.
 .
 This package contains the PDF and HTML documentation.

Package: libngspice0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Spice circuit simulator - library
 NGspice is a mixed-level/mixed-signal circuit simulator. Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
 the built-in OSDI interface.
 .
 This package contains the NGSpice library.

Package: libngspice0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libngspice0 (= ${binary:Version}),
 ${misc:Depends},
Description: Spice circuit simulator - development files for libngspice
 NGSpice is a mixed-level/mixed-signal circuit simulator. Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
 the built-in OSDI interface.
 .
 This package contains the development files for NGSpice.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# out of tree build folder for ngspice application
DEB_BUILD_DIR=debian/build
# default install folder
INSTDIR=$(CURDIR)/debian/tmp

LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

DEB_DEFAULT_CONFIGURE_OPTS := \
	--prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--enable-cider \
	--enable-klu \
	--enable-maintainer-mode \
	--enable-openmp \
	--enable-osdi \
	--enable-pss \
	--enable-xspice \
	--disable-adms \
	--disable-debug \
	$(NULL)

DEB_NGSPICE_CONFIGURE_OPTS := \
	$(DEB_DEFAULT_CONFIGURE_OPTS) \
	--with-editline=yes \
	--with-x \
	$(NULL)

DEB_LIBNGSPICE_CONFIGURE_OPTS := \
	$(DEB_DEFAULT_CONFIGURE_OPTS) \
	--with-ngshared \
	$(NULL)

DEB_TCLSPICE_CONFIGURE_OPTS := \
	$(DEB_DEFAULT_CONFIGURE_OPTS) \
	--with-x \
	--with-tcl=/usr/lib/tcl8.6 \
	$(NULL)

DEB_NGSPICE_DOC_CONFIGURE_OPTS := \
	--prefix=/usr \
	--docdir=\$${prefix}/share/doc/ngspice-doc \
	--htmldir=\$${prefix}/share/doc/ngspice-doc \
	--with-lyxuserdir=$(CURDIR)/$(DEB_BUILD_DIR)/lyxuserdir \
	$(NULL)

PREPROCESS_FILES := $(wildcard debian/*.in)

$(PREPROCESS_FILES:.in=): %: %.in
	sed 's,/@DEB_HOST_MULTIARCH@,$(DEB_HOST_MULTIARCH:%=/%),g' $< > $@

%:
	dh $@

override_dh_clean:
	dh_clean
	rm -f doc/Makefile.in doc/aclocal.m4 doc/configure
	rm -rf debian/build

override_dh_auto_configure-arch:
	mkdir -p $(DEB_BUILD_DIR)
	#
	####################################
	# configuring ngspice applications #
	####################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/ngspice -- $(DEB_NGSPICE_CONFIGURE_OPTS)
	#
	##################################
	# configuring libngspice library #
	##################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/libngspice -- $(DEB_LIBNGSPICE_CONFIGURE_OPTS)
	#
	##############################
	# configure tclspice library #
	##############################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/tclspice -- $(DEB_TCLSPICE_CONFIGURE_OPTS)

override_dh_auto_configure-indep:
	#
	###################################
	# configure ngspice documentation #
	###################################
	cd doc ; autoreconf -vi
	mkdir -p $(DEB_BUILD_DIR)/lyxuserdir/cache
	dh_auto_configure --sourcedirectory=$(CURDIR)/doc --builddirectory=$(DEB_BUILD_DIR)/ngspice-doc -- $(DEB_NGSPICE_DOC_CONFIGURE_OPTS)

override_dh_auto_build-arch:
	#
	#################################
	# building ngspice applications #
	#################################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/ngspice
	#
	###############################
	# building libngspice library #
	###############################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/libngspice
	#
	#############################
	# building tclspice library #
	#############################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/tclspice

override_dh_auto_build-indep:
	#
	##################################
	# building ngspice documentation #
	##################################
	dh_auto_build --sourcedirectory=$(CURDIR)/doc --builddirectory=$(DEB_BUILD_DIR)/ngspice-doc

override_dh_auto_install-arch: $(PREPROCESS_FILES:.in=)
	# We need to install the libngspice and tclspice build first
	# and after that the build of the ngspice applications with
	# X support at the end.
	#
	###############################
	# installing tclspice library #
	###############################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/tclspice
	#
	###################################
	# installing ngspice applications #
	###################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/ngspice
	#
	#################################
	# installing libngspice library #
	#################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/libngspice
	# remove useless *.a and *.la files
	find debian/tmp/ -type f \( -name "*.a" -o -name "*.la" \) -exec rm {} \;
	# remove potential execution rights on *.cm, *.so and *.vpi files
	find debian/tmp/ -type f \( -name "*.cm" -o -name "*.so" -o -name "*.vpi" \) -exec chmod -x {} \;

override_dh_install-indep:
	#
	####################################
	# installing ngspice documentation #
	####################################
	rm -f $(CURDIR)/doc/manual.pdf
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR)/doc --builddirectory=$(DEB_BUILD_DIR)/ngspice-doc
	dh_install

override_dh_install-arch:
	# Ignore the config.h file, it shouldn't be here anyway.
	rm -f debian/tmp/usr/include/config.h
	dh_install

override_dh_installexamples-arch:
	dh_installexamples
	# The example scripts contains a wrong path to the libspice0 library after
	# we have installed them into the package.
	for file in `find debian/tclspice/usr/share/doc/tclspice/examples -type f \( -name "*.sh" -o -name "*.tcl" \)`; do \
	    sed -i 's/^load .*/load \/usr\/lib\/$(DEB_HOST_MULTIARCH)\/libspice.so.0/g' $$file ;\
	    sed -i 's/^spice::codemodel ..\/..\/..\/src\/xspice\/icm\/spice2poly\/spice2poly.cm/spice::codemodel \/usr\/lib\/$(DEB_HOST_MULTIARCH)\/ngspice\/spice2poly.cm/g' $$file ;\
	done
	mv debian/ngspice/usr/share/doc/ngspice/examples/optran/models/Models-for-Debian.txt debian/ngspice/usr/share/doc/ngspice/
	find debian/ngspice/usr/share/doc/ngspice/examples -type f -exec chmod -x {} \;

override_dh_auto_test:

=== debian/tests/control ===
Tests: test-link
Depends: build-essential, libngspice0-dev, pkg-config
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Source: https://git.code.sf.net/p/ngspice/ngspice.git
Matching-Pattern: refs/tags/ngspice-(\d{2}(?:|\.\d+|_\d+|-\d))
Dversionmangle: s/\+ds(\.?\d+)?$//
Mode: git
Uversionmangle: s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/; s/\.\.//; s/_/\./;  s/-/\./

Component: doc
Source: https://git.code.sf.net/p/ngspice/ngspice-manuals.git
Matching-Pattern: refs/tags/ngspice-(\d{2}(?:|\.\d+|_\d+|-\d))
Dversionmangle: s/\+ds(\.?\d+)?$//
Mode: git
